/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/04/30
* Description        : Main program body.
*******************************************************************************/
#include <spidma.h>
#include "debug.h"
#include "sd.h"
#include "ff.h"


//
FATFS fs;                     /* FatFsļϵͳ */
FIL fnew;                     /* ļ */
FRESULT res_sd;               /* ļ */
UINT fnum;                    /* ļɹд */
BYTE ReadBuffer[1024]={0};    /*  */
BYTE WriteBuffer[1024]={0};   /* д*/

static u32 cnt = 0;

void LED_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure={0};            //һGPIO_InitTypeDef͵Ľṹ

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);//ʹLEDصGPIO˿ʱ

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1; //GPIO
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;     //GPIOģʽΪ
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;    //GPIOٶ
    GPIO_Init(GPIOA, &GPIO_InitStructure);               //ÿ⺯ʼGPIOA

    GPIO_SetBits(GPIOA,GPIO_Pin_0|GPIO_Pin_1);           //ߵƽ
}

void TIM1_Int_Init(u16 arr,u16 psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);       //ʹTIM1ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;                    //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler =psc;                  //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;    //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;//TIMģʽϼģʽ
    TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);            //ָĲʼTIMxʱλ

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;         //TIM1ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;  //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;         //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;            //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure);                            //ʼNVIC

    TIM_ITConfig(TIM1,TIM_IT_Update,ENABLE ); //ʹTIM1жϣж

    TIM_Cmd(TIM1, ENABLE); //TIM1ʹ
}

/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main(void)
{
    u32 sd_size;

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    LED_Init();
    TIM1_Int_Init(1000-1,120-1);

    printf("SystemClk:%d\r\n",SystemCoreClock);
    printf("This is SD FATFS example\r\n");

    if(SD_Detect()==0)
    {
        printf("δSD!\n");
    }
    else
    {
        printf("ѼSD!\n");

        if(SD_Initialize())
        {
            printf("SDʼ飡!\n");
            Delay_Ms(500);
        }
        else
        {
            printf("SDʼɣ\n");
            sd_size=SD_GetSectorCount();//õ
            printf("SD Card SizeMB:%d\n",sd_size>>11);
        }
    }

    //ⲿSPI SDļϵͳļϵͳʱSPI豸ʼ
    res_sd = f_mount(&fs,"0:",1);

    /*----------------------- ʽ ---------------------------*/
    /* ûļϵͳ͸ʽļϵͳ */
    if(res_sd == FR_NO_FILESYSTEM)
    {
        printf("SDûļϵͳиʽ...\r\n");
        /* ʽ */
        res_sd=f_mkfs("0:",0,0);

        if(res_sd == FR_OK)
        {
            printf("SDѳɹʽļϵͳ\r\n");
            /* ʽȡ */
            res_sd = f_mount(NULL,"0:",1);
            /* ¹   */
            res_sd = f_mount(&fs,"0:",1);
        }
        else
        {
            printf("ʽʧܡres_sd =%d\r\n",res_sd);
            while(1);
        }
    }
    else if(res_sd!=FR_OK)
    {
        printf("SDļϵͳʧܡ(%d)\r\n",res_sd);
        printf("ԭSDʼɹ\r\n");
        while(1);
    }
    else
    {
        printf("ļϵͳسɹԽжд\r\n");
    }

    /*----------------------- ļϵͳԣд -----------------------------*/
    /* ļļ򴴽 */
    printf("\r\n****** ļд... ******\r\n");
    res_sd = f_open(&fnew, "0:FatFsдļ.txt",FA_CREATE_ALWAYS | FA_WRITE );
    if ( res_sd == FR_OK )
    {
//        printf("/FatFsдļ.txtļɹļдݡ\r\n");

        /***********************************дٶ********************************************/
        printf("cnt1=%d\r\n",cnt);
        /*ָ洢д뵽ļ */
        for(u32 m=0;m<10000;m++)
        {
            res_sd=f_write(&fnew,WriteBuffer,sizeof(WriteBuffer),&fnum);
        }
        printf("cnt2=%d\r\n",cnt);
        /***********************************дٶ********************************************/

        if(res_sd==FR_OK)
        {
//            printf("ļдɹдֽݣ%d\n",fnum);
//            printf("ļдΪ\r\n");
//            for(u32 i=0;i<fnum;i++)
//            {
//                printf(" %d",WriteBuffer[i]);
//            }
//            printf("\r\n");
        }
        else
        {
            printf("ļдʧܣ(%d)\n",res_sd);
        }
        /* ٶдرļ */
        f_close(&fnew);
    }
    else
    {
        printf("/ļʧܡ\r\n");
    }

    /*------------------- ļϵͳԣ ------------------------------------*/
    printf("****** ļȡ... ******\r\n");
    res_sd = f_open(&fnew, "0:FatFsдļ.txt", FA_OPEN_EXISTING | FA_READ);
    if(res_sd == FR_OK)
    {
//        printf("ļɹ\r\n");

        /***********************************Զٶ********************************************/
        cnt=0;
        printf("cnt3=%d\r\n",cnt);
        for(u32 n=0;n<10000;n++)
        {
            res_sd = f_read(&fnew, ReadBuffer, sizeof(ReadBuffer), &fnum);
        }
        printf("cnt4=%d\r\n",cnt);
        /***********************************Զٶ********************************************/

        if(res_sd==FR_OK)
        {
//            printf("ļȡɹ,ֽݣ%d\r\n",fnum);
//            printf("ȡõļΪ\r\n");
//            for(u32 i=0;i<fnum;i++)
//            {
//                printf(" %d", ReadBuffer[i]);
//            }
//            printf("\r\n");
        }
        else
        {
            printf("ļȡʧܣ(%d)\n",res_sd);
        }
    }
    else
    {
        printf("ļʧܡ\r\n");
    }

    /* ٶдرļ */
    f_close(&fnew);

    /* ʹļϵͳȡļϵͳ */
    f_mount(NULL,"0:",1);

    while(1)
    {
    }
}

void TIM1_UP_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM1_UP_IRQHandler(void)
{
//    static u8 i=0;

    if(TIM_GetITStatus(TIM1, TIM_IT_Update) != RESET) //TIM1жǷ
    {
        TIM_ClearITPendingBit(TIM1,TIM_IT_Update);      //TIM1жϹλ
//        GPIO_WriteBit(GPIOA, GPIO_Pin_1, (i==0) ? (i=Bit_SET):(i=Bit_RESET));
        cnt++;
    }
}
